package edu.travel.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import edu.travel.entity.EduTenant;
import edu.travel.entity.SysRole;
import edu.travel.mapper.EduTenantMapper;
import edu.travel.service.SysRoleService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

@Service
public class UserServiceImpl implements UserDetailsService {
    @Autowired
    private EduTenantMapper eduTenantMapper;
    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private SysRoleService sysRoleService;
    @Autowired
    private PasswordEncoder passwordEncoder;
    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        if (StringUtils.isBlank(username)) {
            throw new UsernameNotFoundException("username is empty");
        }
        HttpServletRequest request = ((ServletRequestAttributes) (RequestContextHolder.currentRequestAttributes())).getRequest();
        EduTenant tenant = eduTenantMapper.selectOne(new LambdaQueryWrapper<EduTenant>().eq(EduTenant::getTenantPhone, username));
        if (tenant == null) {
            throw new UsernameNotFoundException("username not found");
        }
        if ("admin".equals(request.getParameter("loginFrom"))) {
            redisTemplate.opsForValue().set(username+"_info", JSON.toJSONString(tenant));

        }else {
            String code = request.getParameter("password");
            if (StringUtils.isBlank(code)) {
                throw new UsernameNotFoundException("验证码为空");
            }
            Object object = "1234";//redisTemplate.opsForValue().get(username+"_user_sms");
            if (object == null) {
                throw new UsernameNotFoundException("验证码为空");
            }
            if (code.equals(object.toString())){
                redisTemplate.opsForValue().set(username+"_info", JSON.toJSONString(tenant));

                return new User(tenant.getTenantPhone(),passwordEncoder.encode(code),new ArrayList<>() );
            }
            throw new UsernameNotFoundException("验证码错误");
        }

        List<SysRole> roleList = sysRoleService.getRoleListByUserId(tenant.getId());
        request.setAttribute("authorities", roleList);
        Set<String> collect = roleList.stream().map(SysRole::getName).collect(Collectors.toSet());
        String[] arr = new String[collect.size()];
        String[] array = collect.toArray(arr);
        return User.builder().username(tenant.getTenantPhone()).password(tenant.getPassword()).roles(array).build();

    }
}
