package edu.travel.tenant;

import edu.travel.remote.feign.mode.dto.tenant.AddMenuDto;
import edu.travel.remote.feign.mode.dto.tenant.SysMenuPageDto;
import edu.travel.remote.feign.mode.vo.tenant.AddMenuVo;
import edu.travel.remote.feign.mode.vo.tenant.MenuTreeVo;
import edu.travel.resp.BaseResponse;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "tenant",path = "/sysMenu")
public interface SysMenuRemoteController {

    /**
     * 新增菜单
     */
    @PostMapping("/addMenu")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse<AddMenuVo> addMenu(@RequestBody AddMenuDto addMenuDto);

    /**
     * 删除菜单单个
     */

    @PostMapping("/deleteMenuById")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse<Boolean> deleteMenuById(@RequestParam Long id) ;

    /**
     * 删除菜单多个
     */
    @PostMapping("/deleteMenuByIds")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse<Boolean> deleteMenuByIds(@RequestBody List<Long> ids );

    /**
     * 获取菜单分页树形列表
     */
    @GetMapping("/getMenuTreeListAll")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse<List<MenuTreeVo>> getMenuTreeListAll(SysMenuPageDto sysMenuPageDto);

    /**
     * 通过菜单id修改菜单
     */
    @PostMapping("/updateMenuById")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse<Boolean> updateMenuById( @RequestBody AddMenuDto updateMenuDto);

}
